<template>
  <div ref="gcjd" class="gcjd" id="gcjd"></div>
</template>

<script>
import {getGcjd} from "@/api/kban";
import echarts from 'echarts'

export default {
  name: "MainGcjd",
  data(){
    return {
      myChart:null,
      show:false,
    }
  },
  mounted() {
    this.getData();
  },
  created(){
    this.delay=setInterval(this.getData,30000)
  },
  methods:{
    getData(){
      this.myChart = echarts.init(document.getElementById("gcjd"),null,{renderer: 'svg'})

      const option = {
        tooltip: {
          trigger: 'axis',
          axisPointer: {
            type: 'shadow'
          }
        },
        grid: {
          top: '10%',
          left: '3%',
          right: '4%',
          bottom: '10%',
          containLabel: true
        },
        legend: {
          top: '3%',
          show: true,
          data: [ { name: '完成张数', }, { name: '未完成张数', } ],
          textStyle: {
            color: 'white'
          },
        },
        xAxis: {
          type: 'value',
          axisLine: { // 控制轴线是否显示
            show: false
          },
          axisLabel: { // 控制轴标签是否显示
            show: false
          }
        },
        yAxis: {
          type: 'category',
          axisLine: { // 控制轴线是否显示
            show: false
          },
          axisLabel: {
            textStyle: {
              fontSize: 9, // 字体大小
              color: 'white' // 字体颜色
            },
          },
          data: []
        },
        series: [
          {
            name:'完成张数',
            type: 'bar',
            data: [20, 30, 15, 10],
            stack: "总量",
            label: {
              show: true, // 显示标签
              position: 'inside', // 标签位置
              formatter: function(params) {
                // params 是一个对象，包含数据的各种信息
                // params.data 是当前项的数据值
                // params.total 是所有项的总和
                // 返回自定义的标签内容
                // return (params.data/1).toFixed(2);
                return ''
              }
            },
            itemStyle: {
              normal: {
                color: function(params) {
                  const colorList = ['green', 'green', 'green', 'green']
                  return 'green'
                }
              }
            }
          },
          {
            name:'未完成张数',
            type: 'bar',
            data: [201, 301, 151, 101],
            stack: "总量",
            label: {
              show: true, // 显示标签
              position: 'inside', // 标签位置
              formatter: function(params) {
                // return (params.data/1).toFixed(2);
                return ''
              }
            },
            itemStyle: {
              normal: {
                color: function(params) {
                  const colorList = ['blue', '#blue', 'blue', 'blue']
                  return 'blue'
                }
              }
            }
          },
          // {
          //   type: 'bar',
          //   data: [],
          //   stack: "总量",
          //   label: {
          //     show: true, // 显示标签
          //     position: 'right', // 标签位置
          //     formatter: params => `${params.data}`
          //   },
          //   itemStyle: {
          //     normal: {
          //       color: function(params) {
          //         const colorList = ['blue', '#blue', 'blue', 'blue']
          //         return 'blue'
          //       }
          //     }
          //   }
          // }
        ]
      }

      getGcjd().then(res=>{
        const czbh=res.data.map(item=>item.dc_ch);
        const complete=res.data.map(item=>item.complete);
        const other=res.data.map(item=>item.total-item.complete);
        const totalData=res.data.map(item=>item.total)
        option.yAxis.data=czbh
        option.series[0].data=complete
        option.series[1].data=other

        option.series.push({
          name:'总张数',
          type: 'bar',
          stack: '总量',
          itemStyle: {
            color: 'white' // 透明颜色
          },
          label: {
            show: true,
            position: 'right',
            formatter: function (params){
              return `${totalData[params.dataIndex]}张`
            }
          },
          data: totalData.map(value => 0.01)// 微小的值以便能显示标签但不影响图形
        });

        this.myChart.setOption(option)
      })
    },
    clear(){
      clearInterval(this.delay)
    }
  }
}
</script>

<style scoped>
.gcjd{
  width: 1470px;
  height: 294px;
  background: url('../../../assets/kban/videobg.png') no-repeat;
  background-size: 1470px 100%;
  margin-top: 14px;
  flex: 1;
  display: flex;
  flex-direction: row;
}
</style>
